#include "jaeil.H"


/****************************************************************************/
/**************************** Init_data.c ***********************************/
/****************************************************************************/

void init_values(int *p, int *k, int *nstr, int *M)
{
  int i;
  /* prior Setting*/  
  for(i=0;i<*M;i++) prior.Mbeta1[i] = 0;
  prior.Vbeta1=5;
  
  for(i=0;i<*p;i++) prior.Mbeta2[i] = 0;
  prior.Vbeta2=5;  
  
	for(i=1;i<param.ksize-1;i++)
	{
		prior.MPhi[i]=0;
	}
	prior.VPhi=5;
	
  /* Initial result Setting*/  
  for(i=0;i<*M;i++) trparam.beta1[i][0] = 0;
  for(i=0;i<trparam.np;i++) trparam.beta2[i][0]     =   0;
  for(i=1;i<trparam.ksize;i++) trparam.phi[i][0] =    1.0/(double)(trparam.ksize-1) * i;  
}

void init_prior(int *p, int *k, int *nstr, int *M)
{
	int i ;
	
  /* Vector size determination*/
  prior.np = *p;						//Z
  prior.ksize =*k;					//Max within Class

	assert(prior.Mbeta1 = (double *) calloc(*M, sizeof(double )));
  assert(prior.Mbeta2 = (double *) calloc(prior.np, sizeof(double )));
  assert(prior.Gprob = (double *) calloc(prior.ksize, sizeof(double )));
	assert(prior.MPhi  = (double *) calloc(prior.ksize, sizeof(double )));

  /* Fix Gprob as the same */
  for(i=0; i<prior.ksize; i++) prior.Gprob[i]=1;
}

/* Parameter Initialize*/
void init_param(int *p, int *k, int *nstr, int *M) 
{
  
  /* Vector size determination*/
  param.np = *p;						//Z
  param.ksize =*k;					//Max within Class
  
  /* Regression Parameters */
	assert(param.beta1 = (double *) calloc(*M, sizeof(double )));
  assert(param.beta2 = (double *) calloc(param.np, sizeof(double )));
  assert(param.gamma = (double *) calloc(param.ksize, sizeof(double )));
  assert(param.phi = (double *)   calloc(param.ksize, sizeof(double )));
  
  /*  Temprary Usage*/  
  assert(param.tmpZ  = (double *) calloc(param.np, sizeof(double )));
}

 /* Parameter Initialize*/
void init_trparam(int *p, int *k, int *nstr, int *M) {
  int i;
  
  /* Vector size determination*/
  trparam.np = *p;						//Z
  trparam.ksize =*k;					//Max within Class
  
  /* Regression Parameters */
	assert(trparam.DIC = (double *) calloc((MAX_ITER-BURN), sizeof(double ))); 

  assert(trparam.beta1 = (double **) calloc(*M, sizeof(double *)));
  for(i=0;i<*M;i++) assert(trparam.beta1[i] = (double *) calloc(MAX_ITER, sizeof(double)));

  assert(trparam.beta2 = (double **) calloc(trparam.np, sizeof(double *)));
  for(i=0;i<trparam.np;i++) assert(trparam.beta2[i] = (double *) calloc(MAX_ITER, sizeof(double)));

  assert(trparam.gamma = (double **) calloc(trparam.ksize, sizeof(double *)));
  for(i=0;i<trparam.ksize;i++) assert(trparam.gamma[i] = (double *) calloc(MAX_ITER, sizeof(double)));

  assert(trparam.phi = (double **) calloc(trparam.ksize, sizeof(double *)));
  for(i=0;i<trparam.ksize;i++) assert(trparam.phi[i] = (double *) calloc(MAX_ITER, sizeof(double)));
}

/* DATA Structure Initialize*/
void init_DATA(int *tot, int *M, int *p) {
  int i;
    
  /* The size of data allocation*/
  data.ntot = *tot;
  data.nM = *M;
  data.p  = *p;
  
  /* data initialize */
  assert(data.Y = (int *) calloc(data.ntot, sizeof(int *)));
  assert(data.X = (double **) calloc(data.ntot, sizeof(double *)));
  for(i=0;i<data.ntot;i++) assert(data.X[i] = (double *) calloc(*p, sizeof(double)));
}

void free_param(int *nstr) 
{
	free(param.beta1);
  free(param.beta2);
  free(param.gamma);
  free(param.phi);
  
  free(param.tmpZ);
}
void free_prior()
{
	free(prior.Mbeta1);
  free(prior.Mbeta2);
  free(prior.Gprob);
	free(prior.MPhi);
}

void free_trparam(int *nstr, int *M) 
{
  int i;
  for(i=0;i<*M;i++) 
		free(trparam.beta1[i]);
	free(trparam.beta1);

  for(i=0;i<trparam.np;i++) 
		free(trparam.beta2[i]);
  free(trparam.beta2);
  
  for(i=0;i<trparam.ksize;i++) free(trparam.gamma[i]);
  free(trparam.gamma);

	for(i=0;i<trparam.ksize;i++) free(trparam.phi[i]);
  free(trparam.phi);
	
	free(trparam.DIC);

}

void free_data(int *nstr, int *p) 
{
  int i;

  free(data.Y);
  for(i=0;i<*p;i++) free(data.X[i]);
  free(data.X);
}


/* Data read : File, num_str, MAX, dim(Z)*/
void read_data(FILE *fp, int *nN, int *nM, int *p) 
{
  int i, k;
  char buf[_MAX_BUF_];
  init_DATA(nN, nM, p); 
  
  for(i=0;i<*nN;i++) 
  {
    fscanf(fp,"%s",buf);
    data.Y[i] = atoi(buf); 
	  for(k=0;k<*p;k++) 
	  {
      fscanf(fp,"%s",buf);
      data.X[i][k] = atof(buf); 
	  }
  }
  
	/* Data verification */
  for(i=0;i<*nN;i++) 
  {
    printf("%d \t%f \t%f \n", data.Y[i], data.X[i][0], data.X[i][1] );
  }
}




